#!/usr/bin/perl -w 

$SIG{ALRM} = sub { die "timeout";};
$timeout = 2;

sub usage(){
    print STDERR "Usage: $0 [-h <host>:<port>] [-j] [-m 'message'] [-f <file>]\n";
    print STDERR "-j :Sending a sequence of command for JIVE experiemnt\n";
    print STDERR "-f <Send File Command sequentially>\n";
    exit(1);
}

# use Exporter;
use IO::Socket;                   # IO::Socket ⥸塼Ȥ
use lib "$ENV{HOME}/prog/perl/module";


my @cmds= qw/"in2net=connect:192.42.120.66" "mode=ext:0xff:1" "play_rate=data:08" "net_protocol=UDP:3200000:10" "in2net=on"/;

my $cnt=0;
{
    usage() if(@ARGV <1);
    my $host = "localhost";
    my $port = 2630;
    my $jive=0;
    my $msg;
    my $infile;
    while(@ARGV){
	my $opt = shift;
	if($opt =~/-h/){
	    usage() unless(@ARGV);
	    my @terms = split(/:/,shift);
	    $host = $terms[0];
	    $port = $terms[1] if(@terms >1);
	}elsif($opt =~/-j/){
	    $jive=1;
	}elsif($opt =~/-f/){
	    $infile=shift;
	}elsif($opt =~/-m/){
	    $msg=shift;
	}
    }

    my $remote = IO::Socket::INET->new(Proto    => "tcp",
				       PeerAddr => $host,
				       PeerPort => $port );
    
    if( ! $remote){	die "Could not connect to $host:$port \n";    }

    select($remote); $|=1; # stop buffering 
    select(STDIN); $|=1; # stop buffering 
    select(STDOUT); $|=1; # stop buffering 

    my $line;
    if($jive){
	while(@cmds){
	    my $cmd = shift(@cmds);
	    print STDOUT " cmd=$cmd\n";
	    eval{ &communicate($remote,"$cmd\n"); };
	    if($@){
		if($@=~/timeout/){
		    print STDERR " Input Time Out-return.\n";
		}else{
		    print STDERR "Error $@\n";
		}
	    }
	}
    }elsif(defined($msg)){
	    print STDOUT " cmd=$msg\n";
	    eval { &communicate($remote,"$msg\n"); };
	    if($@){
		if($@=~/timeout/){
		    print STDERR " Input Time Out-return.\n";
		}else{
		    print STDERR "Error $@\n";
		}
	    }
    }elsif(defined($infile)){
	open(IN,$infile) || die "Cannot open infile[$infile] \n";
	print STDOUT " Sending command in $infile\n";
	my $cnt=0;
	while(<IN>){
	    next if(/^\#/);
	    printf "CMD[%2d] %s\n", $cnt, $_;
	    eval { &communicate($remote,"$_\n"); };
	    if($@){
		if($@=~/timeout/){
		    print STDERR " Input Time Out-return.\n";
		}else{
		    print STDERR "Error $@\n";
		}
	    }
	    $cnt++;
	}
	
    }else{
	while(<STDIN>){
	    $line = $_;
	    print STDOUT  "cmd= $line";
	    eval{ &communicate($remote,$line);};
	    if($@){
		if($@=~/timeout/){
		    print STDERR " Input Time Out-return.\n";
		}else{
		    print STDERR "Error $@\n";
		}
	    }
	}
    }
    

}

sub communicate($$){
    my $socket = shift;
    my $line = shift;

    last unless(defined($socket));
    print $socket $line;
    last unless(defined($socket));
    alarm($timeout);
    while(<$socket>){
	my $res = $_;
	next unless(defined($res));
	chomp($res);
	print STDERR "Res[$cnt]: $res\n" if(defined($res));
	$cnt++;
    }
    alarm(0);    
}
